import java.net.DatagramPacket;
import java.net.InetAddress;
import java.util.Vector;

public class MClientTalker extends UDPTalker
{

    public MClientTalker(MasterClient mc, InetAddress IPAddress, UDPSocket Socket)
    {
        super(NetSettings.ClientPortFirst, NetSettings.ClientPortLast, IPAddress, 10, Socket);
        this.mc = mc;
        PacketVector = new Vector();
    }

    protected void DataSent()
    {
        PacketVector.removeElementAt(0);
    }

    protected DatagramPacket GetPacket()
    {
        DatagramPacket packet = (DatagramPacket)PacketVector.elementAt(0);
        return packet;
    }

    protected boolean SendData()
    {
        return PacketVector.size() > 0;
    }

    public void AddMessageToSend(MessageComposer Message)
    {
        MCLog.MessageLn(5, "[MClientTalker.AddMessageToSend] IN Message: " + (new StatementToText()).GetText(Message.GetStatement()));
        PacketVector.addElement(Message.GetPacket());
        MCLog.MessageLn(5, "[MClientTalker.AddMessageToSend] OUT");
    }

    private Vector PacketVector;
    private MasterClient mc;
    private InetAddress Address;
}
